﻿//******************************************************************************************************
//  ModeDataModel.cs
//
//  Copyright © 2013, Kevin D. Jones.  All Rights Reserved.
//
//  This file is licensed to you under the Eclipse Public License -v 1.0 (the "License"); you may
//  not use this file except in compliance with the License. You may obtain a copy of the License at:
//
//      http://www.opensource.org/licenses/eclipse-1.0.php
//
//  Unless agreed to in writing, the subject software distributed under the License is distributed on an
//  "AS-IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the
//  License for the specific language governing permissions and limitations.
//
//  Code Modification History:
//  ----------------------------------------------------------------------------------------------------
//  07/13/2013 - Kevin D. Jones
//       Generated original version of source code.
//
//******************************************************************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SynchrophasorAnalytics.DataModels
{
    public class NodeDataModel
    {
        private int m_internalID;
        private int m_number;
        private string m_name;
        private string m_description;
        private double m_voltageLevel;
        private string m_parentSubstation;
        private string m_parentTransmissionLine;
        private string m_voltage;

        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public int Number
        {
            get
            {
                return m_number;
            }
            set
            {
                m_number = value;
            }
        }

        public string Name
        {
            get
            {
                return m_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_description;
            }
            set
            {
                m_description = value;
            }
        }

        public double VoltageLevel
        {
            get
            {
                return m_voltageLevel;
            }
            set
            {
                m_voltageLevel = value;
            }
        }

        public string ParentSubstation
        {
            get
            {
                return m_parentSubstation;
            }
            set
            {
                m_parentSubstation = value;
            }
        }

        public string ParentTransmissionLine
        {
            get
            {
                return m_parentTransmissionLine;
            }
            set
            {
                m_parentTransmissionLine = value;
            }
        }

        public string Voltage
        {
            get
            {
                return m_voltage;
            }
            set
            {
                m_voltage = value;
            }
        }

        public NodeDataModel()
            :this(1, 1, "Node Name", "Node Description", 500, "Undefined", "Undefined", "Undefined")
        {
        }

        public NodeDataModel(int internalID, int number, string name, string description, double voltageLevel, string parentSubstation, string parentTransmissionLine, string voltage)
        {

            m_internalID = internalID;
            m_number = number;
            m_name = name;
            m_description = description;
            m_voltageLevel = voltageLevel;
            m_parentSubstation = parentSubstation;
            m_parentTransmissionLine = parentTransmissionLine;
            m_voltage = voltage;

        }

    }
}
