﻿//******************************************************************************************************
//  VoltageLevelDataModel.cs
//
//  Copyright © 2013, Kevin D. Jones.  All Rights Reserved.
//
//  This file is licensed to you under the Eclipse Public License -v 1.0 (the "License"); you may
//  not use this file except in compliance with the License. You may obtain a copy of the License at:
//
//      http://www.opensource.org/licenses/eclipse-1.0.php
//
//  Unless agreed to in writing, the subject software distributed under the License is distributed on an
//  "AS-IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the
//  License for the specific language governing permissions and limitations.
//
//  Code Modification History:
//  ----------------------------------------------------------------------------------------------------
//  07/13/2013 - Kevin D. Jones
//       Generated original version of source code.
//
//******************************************************************************************************

using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace SynchrophasorAnalytics.DataModels
{
    public class VoltageLevelDataModel
    {
        private int m_internalID;
        private double m_baseKV;


        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public double BaseKV
        {
            get
            {
                return m_baseKV;
            }
            set
            {
                m_baseKV = value;
            }
        }

        public VoltageLevelDataModel()
            :this(1, 500)
        {
        }

        public VoltageLevelDataModel(int internalID, double baseKV)
        {
            m_internalID = internalID;
            m_baseKV = baseKV;
        }

    }
}
