﻿//******************************************************************************************************
//  Edge.cs
//
//  Copyright © 2013, Kevin D. Jones.  All Rights Reserved.
//
//  This file is licensed to you under the Eclipse Public License -v 1.0 (the "License"); you may
//  not use this file except in compliance with the License. You may obtain a copy of the License at:
//
//      http://www.opensource.org/licenses/eclipse-1.0.php
//
//  Unless agreed to in writing, the subject software distributed under the License is distributed on an
//  "AS-IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the
//  License for the specific language governing permissions and limitations.
//
//  Code Modification History:
//  ----------------------------------------------------------------------------------------------------
//  06/01/2013 - Kevin D. Jones
//       Generated original version of source code.
//
//******************************************************************************************************
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using SynchrophasorAnalytics.Modeling;

namespace SynchrophasorAnalytics.Graph
{
    public class Edge<ITwoTerminal>
    {
        #region [ Private Members ]

        private Vertex<Node> m_fromVertex;
        private Vertex<Node> m_toVertex;
        private ITwoTerminal m_edge;

        #endregion

        #region [ Properties ]

        public ITwoTerminal Value
        {
            get
            {
                return m_edge;
            }
            set
            {
                m_edge = value;
            }
        }

        public Vertex<Node> FromVertex
        {
            get
            {
                return m_fromVertex;
            }
            set
            {
                m_fromVertex = value;
            }
        }

        public Vertex<Node> ToVertex
        {
            get
            {
                return m_toVertex;
            }
            set
            {
                m_toVertex = value;
            }
        }

        #endregion

        #region [ Constructors ]

        public Edge(ITwoTerminal edge, Vertex<Node> fromVertex, Vertex<Node> toVertex)
        {
            m_edge = edge;
            m_fromVertex = fromVertex;
            m_toVertex = toVertex;
        }

        #endregion
    }
}
