﻿//******************************************************************************************************
//  SnapshotRequest.cs
//
//  Copyright © 2013, Kevin D. Jones.  All Rights Reserved.
//
//  This file is licensed to you under the Eclipse Public License -v 1.0 (the "License"); you may
//  not use this file except in compliance with the License. You may obtain a copy of the License at:
//
//      http://www.opensource.org/licenses/eclipse-1.0.php
//
//  Unless agreed to in writing, the subject software distributed under the License is distributed on an
//  "AS-IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. Refer to the
//  License for the specific language governing permissions and limitations.
//
//  Code Modification History:
//  ----------------------------------------------------------------------------------------------------
//  07/25/2013 - Kevin D. Jones
//       Generated original version of source code.
//
//******************************************************************************************************
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SynchrophasorAnalytics.Testing
{
    public class SnapshotRequest
    {
        private bool m_isComplete;
        private DateTime m_requestTime;

        public bool IsComplete
        {
            get
            {
                return m_isComplete;
            }
            set
            {
                m_isComplete = value;
            }
        }

        public DateTime RequestTime
        {
            get
            {
                return m_requestTime;
            }
            set
            {
                m_requestTime = value;
            }
        }

        public SnapshotRequest()
            :this(DateTime.Now)
        {
        }

        public SnapshotRequest(DateTime requestTime)
        {
            m_requestTime = requestTime;
            m_isComplete = false;
        }
    }
}
