﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SynchrophasorAnalytics.Measurements;

namespace NetworkModelBuilder.DataModels
{
    public class BreakerStatusDataModel
    {

        private int m_internalID;
        private int m_number;
        private string m_name;
        private string m_description;
        private string m_measurementKey;
        private bool m_isEnabled;
        private BreakerStatusBit m_bitPosition;

        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public int Number
        {
            get
            {
                return m_number;
            }
            set
            {
                m_number = value;
            }
        }

        public string Name
        {
            get
            {
                return m_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_description;
            }
            set
            {
                m_description = value;
            }
        }

        public bool IsEnabled
        {
            get
            {
                return m_isEnabled;
            }
            set
            {
                m_isEnabled = value;
            }
        }

        public string MeasurementKey
        {
            get
            {
                return m_measurementKey;
            }
            set
            {
                m_measurementKey = value;
            }
        }

        public BreakerStatusBit BitPosition
        {
            get
            {
                return m_bitPosition;
            }
            set
            {
                m_bitPosition = value;
            }
        }

        public BreakerStatusDataModel()
            :this(1, 1, "Breaker Status Name", "Breaker Status Description", true, "Undefined", BreakerStatusBit.PSV64)
        {
        }

        public BreakerStatusDataModel(int internalID, int number, string name, string description, bool isEnabled, string measurementKey, BreakerStatusBit bitPosition)
        {
            m_internalID = internalID;
            m_number = number;
            m_name = name;
            m_description = description;
            m_isEnabled = isEnabled;
            m_measurementKey = measurementKey;
            m_bitPosition = bitPosition;
        }
    }
}
