﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SynchrophasorAnalytics.Measurements;
using SynchrophasorAnalytics.Modeling;

namespace NetworkModelBuilder.DataModels
{
    public class CircuitBreakerDataModel
    {
        private int m_internalID;
        private int m_number;
        private string m_name;
        private string m_description;
        private string m_key;
        private string m_breakerStatusID;
        private string m_parentSubstation;
        private SwitchingDeviceNormalState m_normalState;

        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public int Number
        {
            get
            {
                return m_number;
            }
            set
            {
                m_number = value;
            }
        }

        public string Name
        {
            get
            {
                return m_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_description;
            }
            set
            {
                m_description = value;
            }
        }

        public string Key
        {
            get
            {
                return m_key;
            }
            set
            {
                m_key = value;
            }
        }

        public SwitchingDeviceNormalState NormalState
        {
            get
            {
                return m_normalState;
            }
            set
            {
                m_normalState = value;
            }
        }

        public string BreakerStatusID
        {
            get
            {
                return m_breakerStatusID;
            }
            set
            {
                m_breakerStatusID = value;
            }
        }

        public string ParentSubstation
        {
            get
            {
                return m_parentSubstation;
            }
            set
            {
                m_parentSubstation = value;
            }
        }
        

        public CircuitBreakerDataModel()
            :this(1, 1, "Circuit Breaker Name", "Circuit Breaker Description", "Undefined", SwitchingDeviceNormalState.Closed, 1, "Undefined")
        {
        }

        public CircuitBreakerDataModel(int internalID, int number, string name, string description, string key, SwitchingDeviceNormalState normalState, int breakerStatusID, string parentSubstation)
        {
            m_internalID = internalID;
            m_number = number;
            m_name = name;
            m_description = description;
            m_key = key;
            m_normalState = normalState;
            m_breakerStatusID = breakerStatusID.ToString();
            m_parentSubstation = parentSubstation;
        }
    }
}
