﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SynchrophasorAnalytics.Calibration;

namespace NetworkModelBuilder.DataModels
{
    public class CurrentPhasorDataModel
    {
        private int m_internalID;
        private int m_number;
        private string m_acronym;
        private string m_name;
        private string m_description;
        private bool m_isEnabled;
        private bool m_useStatusFlagToRemoveMeasurements;
        private int m_fromNode;
        private int m_toNode;
        private string m_measuredBranch;
        private double m_positiveSequenceMeasurementVariance;
        private double m_aPhaseMeasurementVariance;
        private double m_bPhaseMeasurementVariance;
        private double m_cPhaseMeasurementVariance;
        private CalibrationSetting m_calibrationSetting;
        private double m_positiveSequenceRcf;
        private double m_aPhaseRcf;
        private double m_bPhaseRcf;
        private double m_cPhaseRcf;
        private double m_positiveSequencePacf;
        private double m_aPhasePacf;
        private double m_bPhasePacf;
        private double m_cPhasePacf;
        private string m_positiveSequenceMagnitudeMeasurementKey;
        private string m_positiveSequenceAngleMeasurementKey;
        private string m_aPhaseMagnitudeMeasurementKey;
        private string m_aPhaseAngleMeasurementKey;
        private string m_bPhaseMagnitudeMeasurementKey;
        private string m_bPhaseAngleMeasurementKey;
        private string m_cPhaseMagnitudeMeasurementKey;
        private string m_cPhaseAngleMeasurementKey;
        private string m_positiveSequenceMagnitudeEstimateKey;
        private string m_positiveSequenceAngleEstimateKey;
        private string m_aPhaseMagnitudeEstimateKey;
        private string m_aPhaseAngleEstimateKey;
        private string m_bPhaseMagnitudeEstimateKey;
        private string m_bPhaseAngleEstimateKey;
        private string m_cPhaseMagnitudeEstimateKey;
        private string m_cPhaseAngleEstimateKey;

        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public int Number
        {
            get
            {
                return m_number;
            }
            set
            {
                m_number = value;
            }
        }

        public string Acronym
        {
            get
            {
                return m_acronym;
            }
            set
            {
                m_acronym = value;
            }
        }

        public string Name
        {
            get
            {
                return m_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_description;
            }
            set
            {
                m_description = value;
            }
        }

        public bool IsEnabled
        {
            get
            {
                return m_isEnabled;
            }
            set
            {
                m_isEnabled = value;
            }
        }

        public bool UseStatusFlag
        {
            get
            {
                return m_useStatusFlagToRemoveMeasurements;
            }
            set
            {
                m_useStatusFlagToRemoveMeasurements = value;
            }
        }

        public int FromNode
        {
            get
            {
                return m_fromNode;
            }
            set
            {
                m_fromNode = value;
            }
        }

        public int ToNode
        {
            get
            {
                return m_toNode;
            }
            set
            {
                m_toNode = value;
            }
        }

        public string MeasuredBranch
        {
            get
            {
                return m_measuredBranch; 
            }
            set
            {
                m_measuredBranch = value;
            }
        }

        public double PositiveSequenceVariance
        {
            get
            {
                return m_positiveSequenceMeasurementVariance;
            }
            set
            {
                m_positiveSequenceMeasurementVariance = value;
            }
        }

        public double APhaseVariance
        {
            get
            {
                return m_aPhaseMeasurementVariance;
            }
            set
            {
                m_aPhaseMeasurementVariance = value;
            }
        }

        public double BPhaseVariance
        {
            get
            {
                return m_bPhaseMeasurementVariance;
            }
            set
            {
                m_bPhaseMeasurementVariance = value;
            }
        }

        public double CPhaseVariance
        {
            get
            {
                return m_cPhaseMeasurementVariance;
            }
            set
            {
                m_cPhaseMeasurementVariance = value;
            }
        }

        public CalibrationSetting InstrumentTransformerCalibrationSetting
        {
            get
            {
                return m_calibrationSetting;
            }
            set
            {
                m_calibrationSetting = value;
            }
        }

        public double PositiveSequenceRCF
        {
            get
            {
                return m_positiveSequenceRcf;
            }
            set
            {
                m_positiveSequenceRcf = value;
            }
        }

        public double APhaseRCF
        {
            get
            {
                return m_aPhaseRcf;
            }
            set
            {
                m_aPhaseRcf = value;
            }
        }

        public double BPhaseRCF
        {
            get
            {
                return m_bPhaseRcf;
            }
            set
            {
                m_bPhaseRcf = value;
            }
        }

        public double CPhaseRCF
        {
            get
            {
                return m_cPhaseRcf;
            }
            set
            {
                m_cPhaseRcf = value;
            }
        }

        public double PositiveSequencePACF
        {
            get
            {
                return m_positiveSequencePacf;
            }
            set
            {
                m_positiveSequencePacf = value;
            }
        }

        public double APhasePACF
        {
            get
            {
                return m_aPhasePacf;
            }
            set
            {
                m_aPhasePacf = value;
            }
        }

        public double BPhasePACF
        {
            get
            {
                return m_bPhasePacf;
            }
            set
            {
                m_bPhasePacf = value;
            }
        }

        public double CPhasePACF
        {
            get
            {
                return m_cPhasePacf;
            }
            set
            {
                m_cPhasePacf = value;
            }
        }

        public string PositiveSequenceMagnitudeMeasurementKey
        {
            get
            {
                return m_positiveSequenceMagnitudeMeasurementKey;
            }
            set
            {
                m_positiveSequenceMagnitudeMeasurementKey = value;
            }
        }

        public string PositiveSequenceAngleMeasurementKey
        {
            get
            {
                return m_positiveSequenceAngleMeasurementKey;
            }
            set
            {
                m_positiveSequenceAngleMeasurementKey = value;
            }
        }

        public string APhaseMagnitudeMeasurementKey
        {
            get
            {
                return m_aPhaseMagnitudeMeasurementKey;
            }
            set
            {
                m_aPhaseMagnitudeMeasurementKey = value;
            }
        }

        public string APhaseAngleMeasurementKey
        {
            get
            {
                return m_aPhaseAngleMeasurementKey;
            }
            set
            {
                m_aPhaseAngleMeasurementKey = value;
            }
        }

        public string BPhaseMagnitudeMeasurementKey
        {
            get
            {
                return m_bPhaseMagnitudeMeasurementKey;
            }
            set
            {
                m_bPhaseMagnitudeMeasurementKey = value;
            }
        }

        public string BPhaseAngleMeasurementKey
        {
            get
            {
                return m_bPhaseAngleMeasurementKey;
            }
            set
            {
                m_bPhaseAngleMeasurementKey = value;
            }
        }

        public string CPhaseMagnitudeMeasurementKey
        {
            get
            {
                return m_cPhaseMagnitudeMeasurementKey;
            }
            set
            {
                m_cPhaseMagnitudeMeasurementKey = value;
            }
        }

        public string CPhaseAngleMeasurementKey
        {
            get
            {
                return m_cPhaseAngleMeasurementKey;
            }
            set
            {
                m_cPhaseAngleMeasurementKey = value;
            }
        }

        public string PositiveSequenceMagnitudeEstimateKey
        {
            get
            {
                return m_positiveSequenceMagnitudeEstimateKey;
            }
            set
            {
                m_positiveSequenceMagnitudeEstimateKey = value;
            }
        }

        public string PositiveSequenceAngleEstimateKey
        {
            get
            {
                return m_positiveSequenceAngleEstimateKey;
            }
            set
            {
                m_positiveSequenceAngleEstimateKey = value;
            }
        }

        public string APhaseMagnitudeEstimateKey
        {
            get
            {
                return m_aPhaseMagnitudeEstimateKey;
            }
            set
            {
                m_aPhaseMagnitudeEstimateKey = value;
            }
        }

        public string APhaseAngleEstimateKey
        {
            get
            {
                return m_aPhaseAngleEstimateKey;
            }
            set
            {
                m_aPhaseAngleEstimateKey = value;
            }
        }

        public string BPhaseMagnitudeEstimateKey
        {
            get
            {
                return m_bPhaseMagnitudeEstimateKey;
            }
            set
            {
                m_bPhaseMagnitudeEstimateKey = value;
            }
        }

        public string BPhaseAngleEstimateKey
        {
            get
            {
                return m_bPhaseAngleEstimateKey;
            }
            set
            {
                m_bPhaseAngleEstimateKey = value;
            }
        }

        public string CPhaseMagnitudeEstimateKey
        {
            get
            {
                return m_cPhaseMagnitudeEstimateKey;
            }
            set
            {
                m_cPhaseMagnitudeEstimateKey = value;
            }
        }

        public string CPhaseAngleEstimateKey
        {
            get
            {
                return m_cPhaseAngleEstimateKey;
            }
            set
            {
                m_cPhaseAngleEstimateKey = value;
            }
        }

        public CurrentPhasorDataModel()
            : this(1, 2, "AMPS", "Current Phasor Name", "Current Phasor Description", true, true, 0.002, 0.002, 0.002, 0.002, 1, 2, "Measured Branch Description", CalibrationSetting.Inactive, 1, 0, "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined", "Undefined")
        {
        }

        public CurrentPhasorDataModel(int internalID, int number, string acronym, string name, string description, bool isEnabled, bool useStatusFlags, double positiveSequenceVariance, double aPhaseVariance, double bPhaseVariance, double cPhaseVariance, int fromNode, int toNode, string measuredBranch, CalibrationSetting calibrationSetting, double rcf, double pacf, string positiveSequenceMagnitudeMeasurementKey, string positiveSequenceAngleMeasurementKey, string aPhaseMagnitudeMeasurementKey, string aPhaseAngleMeasurementKey, string bPhaseMagnitudeMeasurementKey, string bPhaseAngleMeasurementKey, string cPhaseMagnitudeMeasurementKey, string cPhaseAngleMeasurementKey, string positiveSequenceMagnitudeEstimateKey, string positiveSequenceAngleEstimateKey, string aPhaseMagnitudeEstimateKey, string aPhaseAngleEstimateKey, string bPhaseMagnitudeEstimateKey, string bPhaseAngleEstimateKey, string cPhaseMagnitudeEstimateKey, string cPhaseAngleEstimateKey)
        {
            m_internalID = internalID;
            m_number = number;
            m_acronym = acronym;
            m_name = name;
            m_description = description;
            m_isEnabled = isEnabled;
            m_useStatusFlagToRemoveMeasurements = useStatusFlags;
            m_fromNode = fromNode;
            m_toNode = toNode;
            m_measuredBranch = measuredBranch;
            m_positiveSequenceMeasurementVariance = positiveSequenceVariance;
            m_aPhaseMeasurementVariance = aPhaseVariance;
            m_bPhaseMeasurementVariance = bPhaseVariance;
            m_cPhaseMeasurementVariance = cPhaseVariance;
            m_calibrationSetting = calibrationSetting;
            m_positiveSequenceRcf = rcf;
            m_positiveSequencePacf = pacf;
            m_positiveSequenceMagnitudeMeasurementKey = positiveSequenceMagnitudeMeasurementKey;
            m_positiveSequenceAngleMeasurementKey = positiveSequenceAngleMeasurementKey;
            m_aPhaseMagnitudeMeasurementKey = aPhaseMagnitudeMeasurementKey;
            m_aPhaseAngleMeasurementKey = aPhaseAngleMeasurementKey;
            m_bPhaseMagnitudeMeasurementKey = bPhaseMagnitudeMeasurementKey;
            m_bPhaseAngleMeasurementKey = bPhaseAngleMeasurementKey;
            m_cPhaseMagnitudeMeasurementKey = cPhaseMagnitudeMeasurementKey;
            m_cPhaseAngleMeasurementKey = cPhaseAngleMeasurementKey;
            m_positiveSequenceMagnitudeEstimateKey = positiveSequenceMagnitudeEstimateKey;
            m_positiveSequenceAngleEstimateKey = positiveSequenceAngleEstimateKey;
            m_aPhaseMagnitudeEstimateKey = aPhaseMagnitudeEstimateKey;
            m_aPhaseAngleEstimateKey = aPhaseAngleEstimateKey;
            m_bPhaseMagnitudeEstimateKey = bPhaseMagnitudeEstimateKey;
            m_bPhaseAngleEstimateKey = bPhaseAngleEstimateKey;
            m_cPhaseMagnitudeEstimateKey = cPhaseMagnitudeEstimateKey;
            m_cPhaseAngleEstimateKey = cPhaseAngleEstimateKey;
        }
    }
}
