﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NetworkModelBuilder.DataModels
{
    public class TapConfigurationDataModel
    {
        private int m_internalID;
        private string m_acronym;
        private string m_name;
        private string m_description;
        private double m_lowerBounds;
        private double m_upperBounds;
        private int m_positionLowerBounds;
        private int m_positionUpperBounds;
        private int m_positionNominal;

        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public string Acronym
        {
            get
            {
                return m_acronym;
            }
            set
            {
                m_acronym = value;
            }
        }

        public string Name
        {
            get
            {
                return m_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_description;
            }
            set
            {
                m_description = value;
            }
        }

        public double LowerBounds
        {
            get
            {
                return m_lowerBounds;
            }
            set
            {
                m_lowerBounds = value;
            }
        }

        public double UpperBounds
        {
            get
            {
                return m_upperBounds;
            }
            set
            {
                m_upperBounds = value;
            }
        }

        public int PositionLowerBounds
        {
            get
            {
                return m_positionLowerBounds;
            }
            set
            {
                m_positionLowerBounds = value;
            }
        }

        public int PositionUpperBounds
        {
            get
            {
                return m_positionUpperBounds;
            }
            set
            {
                m_positionUpperBounds = value;
            }
        }

        public int PositionNominal
        {
            get
            {
                return m_positionNominal;
            }
            set
            {
                m_positionNominal = value;
            }
        }

        public TapConfigurationDataModel()
            :this(1, "TAP", "Tap Configuration Name", "Tap Configuration Description", 0.92, 1.08, -16, 16, 0)
        {
        }

        public TapConfigurationDataModel(int internalID, string acronym, string name, string description, double lowerBounds, double upperBounds, int positionLowerBounds, int positionUpperBounds, int positionNominal)
        {
            m_internalID = internalID;
            m_acronym = acronym;
            m_name = name;
            m_description = description;
            m_lowerBounds = lowerBounds;
            m_upperBounds = upperBounds;
            m_positionLowerBounds = positionLowerBounds;
            m_positionUpperBounds = positionUpperBounds;
            m_positionNominal = positionNominal;
        }
    }
}
