﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using SynchrophasorAnalytics.Modeling;

namespace NetworkModelBuilder.DataModels
{
    public class TransformerDataModel
    {
        private int m_internalID;
        private int m_number;
        private string m_name;
        private string m_description;
        private string m_parentSubstation;
        private int m_fromNode;
        private int m_toNode;
        private string m_fromCurrent;
        private string m_toCurrent;
        private string m_tapConfiguration;
        private TransformerType m_transformerType;
        private double m_R1;
        private double m_R2;
        private double m_R3;
        private double m_R4;
        private double m_R5;
        private double m_R6;
        private double m_X1;
        private double m_X2;
        private double m_X3;
        private double m_X4;
        private double m_X5;
        private double m_X6;
        private double m_B1;
        private double m_B2;
        private double m_B3;
        private double m_B4;
        private double m_B5;
        private double m_B6;

        public int InternalID
        {
            get
            {
                return m_internalID;
            }
            set
            {
                m_internalID = value;
            }
        }

        public int Number
        {
            get
            {
                return m_number;
            }
            set
            {
                m_number = value;
            }
        }

        public string Name
        {
            get
            {
                return m_name;
            }
            set
            {
                m_name = value;
            }
        }

        public string Description
        {
            get
            {
                return m_description;
            }
            set
            {
                m_description = value;
            }
        }

        public string ParentSubstation
        {
            get
            {
                return m_parentSubstation;
            }
            set
            {
                m_parentSubstation = value;
            }
        }

        public int FromNode
        {
            get
            {
                return m_fromNode;
            }
            set
            {
                m_fromNode = value;
            }
        }

        public int ToNode
        {
            get
            {
                return m_toNode;
            }
            set
            {
                m_toNode = value;
            }
        }

        public string FromCurrent
        {
            get
            {
                return m_fromCurrent;
            }
            set
            {
                m_fromCurrent = value;
            }
        }

        public string ToCurrent
        {
            get
            {
                return m_toCurrent;
            }
            set
            {
                m_toCurrent = value;
            }
        }

        public string Tap
        {
            get
            {
                return m_tapConfiguration;
            }
            set
            {
                m_tapConfiguration = value;
            }
        }

        public TransformerType Type
        {
            get
            {
                return m_transformerType;
            }
            set
            {
                m_transformerType = value;
            }
        }

        public double R1
        {
            get
            {
                return m_R1;
            }
            set
            {
                m_R1 = value;
            }
        }

        public double R2
        {
            get
            {
                return m_R2;
            }
            set
            {
                m_R2 = value;
            }
        }

        public double R3
        {
            get
            {
                return m_R3;
            }
            set
            {
                m_R3 = value;
            }
        }

        public double R4
        {
            get
            {
                return m_R4;
            }
            set
            {
                m_R4 = value;
            }
        }

        public double R5
        {
            get
            {
                return m_R5;
            }
            set
            {
                m_R5 = value;
            }
        }

        public double R6
        {
            get
            {
                return m_R6;
            }
            set
            {
                m_R6 = value;
            }
        }

        public double X1
        {
            get
            {
                return m_X1;
            }
            set
            {
                m_X1 = value;
            }
        }

        public double X2
        {
            get
            {
                return m_X2;
            }
            set
            {
                m_X2 = value;
            }
        }

        public double X3
        {
            get
            {
                return m_X3;
            }
            set
            {
                m_X3 = value;
            }
        }

        public double X4
        {
            get
            {
                return m_X4;
            }
            set
            {
                m_X4 = value;
            }
        }

        public double X5
        {
            get
            {
                return m_X5;
            }
            set
            {
                m_X5 = value;
            }
        }

        public double X6
        {
            get
            {
                return m_X6;
            }
            set
            {
                m_X6 = value;
            }
        }


        public double B1
        {
            get
            {
                return m_B1;
            }
            set
            {
                m_B1 = value;
            }
        }

        public double B2
        {
            get
            {
                return m_B2;
            }
            set
            {
                m_B2 = value;
            }
        }

        public double B3
        {
            get
            {
                return m_B3;
            }
            set
            {
                m_B3 = value;
            }
        }

        public double B4
        {
            get
            {
                return m_B4;
            }
            set
            {
                m_B4 = value;
            }
        }

        public double B5
        {
            get
            {
                return m_B5;
            }
            set
            {
                m_B5 = value;
            }
        }

        public double B6
        {
            get
            {
                return m_B6;
            }
            set
            {
                m_B6 = value;
            }
        }

        public TransformerDataModel()
            :this(1, 1, "TL", "Transformer Name", "Transformer Description", "Undefined", 0, 0, "Undefined", "Undefined", "Undefined", TransformerType.WyeWye, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0)
        {
        }

        public TransformerDataModel(int internalID, int number, string acronym, string name, string description, string parentSubstation, int fromNode, int toNode, string fromCurrent, string toCurrent, string tapConfiguration, TransformerType type, double r1, double r2, double r3, double r4, double r5, double r6, double x1, double x2, double x3, double x4, double x5, double x6, double b1, double b2, double b3, double b4, double b5, double b6)
        {
            m_internalID = internalID;
            m_number = number;
            m_name = name;
            m_description = description;
            m_parentSubstation = parentSubstation;
            m_fromNode = fromNode;
            m_toNode = toNode;
            m_fromCurrent = fromCurrent;
            m_toCurrent = toCurrent;
            m_tapConfiguration = tapConfiguration;
            m_transformerType = type;
            m_R1 = r1;
            m_R2 = r2;
            m_R3 = r3;
            m_R4 = r4;
            m_R5 = r5;
            m_R6 = r6;
            m_X1 = x1;
            m_X2 = x2;
            m_X3 = x3;
            m_X4 = x4;
            m_X5 = x5;
            m_X6 = x6;
            m_B1 = b1;
            m_B2 = b2;
            m_B3 = b3;
            m_B4 = b4;
            m_B5 = b5;
            m_B6 = b6;
        }
    }
}
