﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using NetworkModelBuilder.ViewModels;
using FirstFloor.ModernUI.Windows.Controls;

namespace NetworkModelBuilder.Pages
{
    /// <summary>
    /// Interaction logic for InstrumentTransformerCalibrationUserControl.xaml
    /// </summary>
    public partial class InstrumentTransformerCalibrationUserControl : UserControl
    {
        public InstrumentTransformerCalibrationUserControl()
        {
            InitializeComponent();
            CalibrationForm.DataContext = new InstrumentTransformerCalibrationViewModel();
            UseConfigurationRadioButton.IsChecked = true;
            ToggleCaseTextBoxes(false);
        }

        private void ToggleCaseTextBoxes(bool desiredState)
        {
            Case01TextBox.IsEnabled = desiredState;
            Case02TextBox.IsEnabled = desiredState;
            Case03TextBox.IsEnabled = desiredState;
            Case04TextBox.IsEnabled = desiredState;
            Case05TextBox.IsEnabled = desiredState;
            Case06TextBox.IsEnabled = desiredState;
            Case07TextBox.IsEnabled = desiredState;
            Case08TextBox.IsEnabled = desiredState;
            Case09TextBox.IsEnabled = desiredState;
            Case10TextBox.IsEnabled = desiredState;
            Case11TextBox.IsEnabled = desiredState;
            Case12TextBox.IsEnabled = desiredState;
            Case13TextBox.IsEnabled = desiredState;
            Case14TextBox.IsEnabled = desiredState;
            Case15TextBox.IsEnabled = desiredState;
            Case16TextBox.IsEnabled = desiredState;
            LoadConfigurationButton.IsEnabled = !desiredState;
        }

        private void ValidateButton_Click(object sender, RoutedEventArgs e)
        {

        }

        private void CalibrateButton_Click(object sender, RoutedEventArgs e)
        {

        }

        private void SaveButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                (CalibrationForm.DataContext as InstrumentTransformerCalibrationViewModel).SerializeToXml(DirectoryPathNameTextBox.Text);
                ModernDialog.ShowMessage("Configuration successfully saved to " + DirectoryPathNameTextBox.Text, "Saved", MessageBoxButton.OK);
            }
            catch (Exception exception)
            {
                ModernDialog.ShowMessage("Failed to save configuration: " + exception.ToString(), "Error", MessageBoxButton.OK);
            }
        }

        private void CalibrationUserControl_Loaded(object sender, RoutedEventArgs e)
        {
            
        }

        private void ManualRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            ToggleCaseTextBoxes(true);
        }

        private void UseConfigurationRadioButton_Checked(object sender, RoutedEventArgs e)
        {
            ToggleCaseTextBoxes(false);
        }

        private void LoadConfigurationButton_Click(object sender, RoutedEventArgs e)
        {
            try
            {
                CalibrationForm.DataContext = InstrumentTransformerCalibrationViewModel.DeserializeFromXml(DirectoryPathNameTextBox.Text);
            }
            catch (Exception exception)
            {
                ModernDialog.ShowMessage("Failed to load configuration: " + exception.ToString(), "Error", MessageBoxButton.OK);
            }
        }
    }
}
