﻿using FirstFloor.ModernUI.Presentation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Xml.Serialization;
using System.IO;

namespace NetworkModelBuilder.ViewModels
{
    [Serializable()]
    [XmlRoot("CalibrationAnalysisSettings")]
    public class InstrumentTransformerCalibrationViewModel : NotifyPropertyChanged, IDataErrorInfo
    {
        private string m_case01FileName;
        private string m_case02FileName;
        private string m_case03FileName;
        private string m_case04FileName;
        private string m_case05FileName;
        private string m_case06FileName;
        private string m_case07FileName;
        private string m_case08FileName;
        private string m_case09FileName;
        private string m_case10FileName;
        private string m_case11FileName;
        private string m_case12FileName;
        private string m_case13FileName;
        private string m_case14FileName;
        private string m_case15FileName;
        private string m_case16FileName;

        private string m_directoryPathName;

        [XmlElement("SourceDirectory")]
        public string DirectoryPathName
        {
            get
            {
                return m_directoryPathName;
            }
            set
            {
                if (m_directoryPathName != value)
                {
                    m_directoryPathName = value;
                    OnPropertyChanged("DirectoryPathName");
                }
            }
        }

        [XmlElement("Case01")]
        public string Case01FileName
        {
            get
            {
                return m_case01FileName;
            }
            set
            {
                if (m_case01FileName != value)
                {
                    m_case01FileName = value;
                    OnPropertyChanged("Case01FileName");
                }
            }
        }

        [XmlElement("Case02")]
        public string Case02FileName
        {
            get
            {
                return m_case02FileName;
            }
            set
            {
                if (m_case02FileName != value)
                {
                    m_case02FileName = value;
                    OnPropertyChanged("Case02FileName");
                }
            }
        }

        [XmlElement("Case03")]
        public string Case03FileName
        {
            get
            {
                return m_case03FileName;
            }
            set
            {
                if (m_case03FileName != value)
                {
                    m_case03FileName = value;
                    OnPropertyChanged("Case03FileName");
                }
            }
        }

        [XmlElement("Case04")]
        public string Case04FileName
        {
            get
            {
                return m_case04FileName;
            }
            set
            {
                if (m_case04FileName != value)
                {
                    m_case04FileName = value;
                    OnPropertyChanged("Case04FileName");
                }
            }
        }

        [XmlElement("Case05")]
        public string Case05FileName
        {
            get
            {
                return m_case05FileName;
            }
            set
            {
                if (m_case05FileName != value)
                {
                    m_case05FileName = value;
                    OnPropertyChanged("Case05FileName");
                }
            }
        }

        [XmlElement("Case06")]
        public string Case06FileName
        {
            get
            {
                return m_case06FileName;
            }
            set
            {
                if (m_case06FileName != value)
                {
                    m_case06FileName = value;
                    OnPropertyChanged("Case06FileName");
                }
            }
        }

        [XmlElement("Case07")]
        public string Case07FileName
        {
            get
            {
                return m_case07FileName;
            }
            set
            {
                if (m_case07FileName != value)
                {
                    m_case07FileName = value;
                    OnPropertyChanged("Case07FileName");
                }
            }
        }

        [XmlElement("Case08")]
        public string Case08FileName
        {
            get
            {
                return m_case08FileName;
            }
            set
            {
                if (m_case08FileName != value)
                {
                    m_case08FileName = value;
                    OnPropertyChanged("Case08FileName");
                }
            }
        }

        [XmlElement("Case09")]
        public string Case09FileName
        {
            get
            {
                return m_case09FileName;
            }
            set
            {
                if (m_case09FileName != value)
                {
                    m_case09FileName = value;
                    OnPropertyChanged("Case09FileName");
                }
            }
        }

        [XmlElement("Case10")]
        public string Case10FileName
        {
            get
            {
                return m_case10FileName;
            }
            set
            {
                if (m_case10FileName != value)
                {
                    m_case10FileName = value;
                    OnPropertyChanged("Case10FileName");
                }
            }
        }

        [XmlElement("Case11")]
        public string Case11FileName
        {
            get
            {
                return m_case11FileName;
            }
            set
            {
                if (m_case11FileName != value)
                {
                    m_case11FileName = value;
                    OnPropertyChanged("Case11FileName");
                }
            }
        }

        [XmlElement("Case12")]
        public string Case12FileName
        {
            get
            {
                return m_case12FileName;
            }
            set
            {
                if (m_case12FileName != value)
                {
                    m_case12FileName = value;
                    OnPropertyChanged("Case12FileName");
                }
            }
        }

        [XmlElement("Case13")]
        public string Case13FileName
        {
            get
            {
                return m_case13FileName;
            }
            set
            {
                if (m_case13FileName != value)
                {
                    m_case13FileName = value;
                    OnPropertyChanged("Case13FileName");
                }
            }
        }

        [XmlElement("Case14")]
        public string Case14FileName
        {
            get
            {
                return m_case14FileName;
            }
            set
            {
                if (m_case14FileName != value)
                {
                    m_case14FileName = value;
                    OnPropertyChanged("Case14FileName");
                }
            }
        }

        [XmlElement("Case15")]
        public string Case15FileName
        {
            get
            {
                return m_case15FileName;
            }
            set
            {
                if (m_case15FileName != value)
                {
                    m_case15FileName = value;
                    OnPropertyChanged("Case15FileName");
                }
            }
        }

        [XmlElement("Case16")]
        public string Case16FileName
        {
            get
            {
                return m_case16FileName;
            }
            set
            {
                if (m_case16FileName != value)
                {
                    m_case16FileName = value;
                    OnPropertyChanged("Case16FileName");
                }
            }
        }

        public InstrumentTransformerCalibrationViewModel()
            :this("C:/"," ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ", " ")
        {
        }

        public InstrumentTransformerCalibrationViewModel(string directory, string case01, string case02, string case03, string case04, string case05, string case06, string case07, string case08, string case09, string case10, string case11, string case12, string case13, string case14, string case15, string case16)
        {
            m_directoryPathName = directory;

            m_case01FileName = case01;
            m_case02FileName = case02;
            m_case03FileName = case03;
            m_case04FileName = case04;
            m_case05FileName = case05;
            m_case06FileName = case06;
            m_case07FileName = case07;
            m_case08FileName = case08;
            m_case09FileName = case09;
            m_case10FileName = case10;
            m_case11FileName = case11;
            m_case12FileName = case12;
            m_case13FileName = case13;
            m_case14FileName = case14;
            m_case15FileName = case15;
            m_case16FileName = case16;
        }

        public string Error
        {
            get 
            { 
                return null; 
            }
        }

        public string this[string columnName]
        {
            get
            {
                if (columnName == "DirectoryPathName")
                {
                    return string.IsNullOrEmpty(this.m_directoryPathName) ? "Required value" : null;
                }
                return null;
            }
        }

        /// <summary>
        /// Creates a new <see cref="InstrumentTransformerCalibrationViewModel"/> by deserializing the configuration file from the specified location.
        /// </summary>
        /// <param name="pathName">The location of the configuration file including the file name.</param>
        /// <returns>A new <see cref="InstrumentTransformerCalibrationViewModel"/> based on the configuration file.</returns>
        public static InstrumentTransformerCalibrationViewModel DeserializeFromXml(string pathName)
        {
            try
            {
                // Create an empy NetworkModel object reference.
                InstrumentTransformerCalibrationViewModel viewModel = null;

                // Create an XmlSerializer with the type of NetworkModel.
                XmlSerializer deserializer = new XmlSerializer(typeof(InstrumentTransformerCalibrationViewModel));

                // Read the data in from the file.
                StreamReader reader = new StreamReader(pathName);

                // Cast the deserialized data as a NetworkModel object.
                viewModel = (InstrumentTransformerCalibrationViewModel)deserializer.Deserialize(reader);

                // Close the connection.
                reader.Close();

                return viewModel;
            }
            catch (Exception exception)
            {
                throw new Exception("Failed to Deserialize the Calibration Settings from the Configuration File: " + exception.ToString());
            }
        }

        /// <summary>
        /// Serialized the <see cref="InstrumentTransformerCalibrationViewModel"/> to the specified file.
        /// </summary>
        /// <param name="pathName">The directory name included the file name of the desired location for Xml Serialization.</param>
        public void SerializeToXml(string pathName)
        {
            try
            {
                // Create an XmlSerializer with the type of NetworkModel
                XmlSerializer serializer = new XmlSerializer(typeof(InstrumentTransformerCalibrationViewModel));

                // Open a connection to the file and path.
                TextWriter writer = new StreamWriter(pathName);

                // Serialize this instance of NetworkModel
                serializer.Serialize(writer, this);

                // Close the connection
                writer.Close();
            }
            catch (Exception exception)
            {
                throw new Exception("Failed to Serialize the Calibration Settings to the Configuration File: " + exception.ToString());
            }
        }
    }
}
