﻿using FirstFloor.ModernUI.Presentation;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace NetworkModelBuilder.ViewModels
{
    public class SettingsViewModel
        : NotifyPropertyChanged, IDataErrorInfo
    {
        private string m_workingDirectory;

        public string WorkingDirectory
        {
            get
            {
                return m_workingDirectory;
            }
            set
            {
                if (m_workingDirectory != value)
                {
                    m_workingDirectory = value;
                    OnPropertyChanged("WorkingDirectory");
                }
            }
        }

        public string Error
        {
            get 
            { 
                return null; 
            }
        }

        public string this[string columnName]
        {
            get
            {
                if (columnName == "WorkingDirectory")
                {
                    return string.IsNullOrEmpty(m_workingDirectory) ? "Required value" : null;
                }
                return null;
            }
        }
    }
}
